/*
 * err.c
 * $Revision: 1.2 $
 *
 * Copyright (c) 2004 David Holroyd
 * See the file COPYING for license terms
 *
 * http://www.badgers-in-foil.co.uk/projects/cvprof/
 */


#include "err.h"

void report_jvmdi_error(char *message, jvmdiError err)
{
	char *error_text = NULL;
	switch (err) {
	    case JVMDI_ERROR_INVALID_THREAD:
		error_text = "JVMDI_ERROR_INVALID_THREAD";
		break;
	    case JVMDI_ERROR_INVALID_THREAD_GROUP:
		error_text = "JVMDI_ERROR_INVALID_THREAD_GROUP";
		break;
	    case JVMDI_ERROR_INVALID_PRIORITY:
		error_text = "JVMDI_ERROR_INVALID_PRIORITY";
		break;
	    case JVMDI_ERROR_THREAD_NOT_SUSPENDED:
		error_text = "JVMDI_ERROR_THREAD_NOT_SUSPENDED";
		break;
	    case JVMDI_ERROR_THREAD_SUSPENDED:
		error_text = "JVMDI_ERROR_THREAD_SUSPENDED";
		break;
	    case JVMDI_ERROR_INVALID_OBJECT:
		error_text = "JVMDI_ERROR_INVALID_OBJECT";
		break;
	    case JVMDI_ERROR_INVALID_CLASS:
		error_text = "JVMDI_ERROR_INVALID_CLASS";
		break;
	    case JVMDI_ERROR_CLASS_NOT_PREPARED:
		error_text = "JVMDI_ERROR_CLASS_NOT_PREPARED";
		break;
	    case JVMDI_ERROR_INVALID_METHODID:
		error_text = "JVMDI_ERROR_INVALID_METHODID";
		break;
	    case JVMDI_ERROR_INVALID_LOCATION:
		error_text = "JVMDI_ERROR_INVALID_LOCATION";
		break;
	    case JVMDI_ERROR_INVALID_FIELDID:
		error_text = "JVMDI_ERROR_INVALID_FIELDID";
		break;
	    case JVMDI_ERROR_INVALID_FRAMEID:
		error_text = "JVMDI_ERROR_INVALID_FRAMEID";
		break;
	    case JVMDI_ERROR_NO_MORE_FRAMES:
		error_text = "JVMDI_ERROR_NO_MORE_FRAMES";
		break;
	    case JVMDI_ERROR_OPAQUE_FRAME:
		error_text = "JVMDI_ERROR_OPAQUE_FRAME";
		break;
	    case JVMDI_ERROR_NOT_CURRENT_FRAME:
		error_text = "JVMDI_ERROR_NOT_CURRENT_FRAME";
		break;
	    case JVMDI_ERROR_TYPE_MISMATCH:
		error_text = "JVMDI_ERROR_TYPE_MISMATCH";
		break;
	    case JVMDI_ERROR_INVALID_SLOT:
		error_text = "JVMDI_ERROR_INVALID_SLOT";
		break;
	    case JVMDI_ERROR_DUPLICATE:
		error_text = "JVMDI_ERROR_DUPLICATE";
		break;
	    case JVMDI_ERROR_NOT_FOUND:
		error_text = "JVMDI_ERROR_NOT_FOUND";
		break;
	    case JVMDI_ERROR_INVALID_MONITOR:
		error_text = "JVMDI_ERROR_INVALID_MONITOR";
		break;
	    case JVMDI_ERROR_NOT_MONITOR_OWNER:
		error_text = "JVMDI_ERROR_NOT_MONITOR_OWNER";
		break;
	    case JVMDI_ERROR_INTERRUPT:
		error_text = "JVMDI_ERROR_INTERRUPT";
		break;
	    case JVMDI_ERROR_INVALID_CLASS_FORMAT:
		error_text = "JVMDI_ERROR_INVALID_CLASS_FORMAT";
		break;
	    case JVMDI_ERROR_CIRCULAR_CLASS_DEFINITION:
		error_text = "JVMDI_ERROR_CIRCULAR_CLASS_DEFINITION";
		break;
	    case JVMDI_ERROR_FAILS_VERIFICATION:
		error_text = "JVMDI_ERROR_FAILS_VERIFICATION";
		break;
	    case JVMDI_ERROR_ADD_METHOD_NOT_IMPLEMENTED:
		error_text = "JVMDI_ERROR_ADD_METHOD_NOT_IMPLEMENTED";
		break;
	    case JVMDI_ERROR_SCHEMA_CHANGE_NOT_IMPLEMENTED:
		error_text = "JVMDI_ERROR_SCHEMA_CHANGE_NOT_IMPLEMENTED";
		break;
	    case JVMDI_ERROR_INVALID_TYPESTATE:
		error_text = "JVMDI_ERROR_INVALID_TYPESTATE";
		break;
	    case JVMDI_ERROR_NOT_IMPLEMENTED:
		error_text = "JVMDI_ERROR_NOT_IMPLEMENTED";
		break;
	    case JVMDI_ERROR_NULL_POINTER:
		error_text = "JVMDI_ERROR_NULL_POINTER";
		break;
	    case JVMDI_ERROR_ABSENT_INFORMATION:
		error_text = "JVMDI_ERROR_ABSENT_INFORMATION";
		break;
	    case JVMDI_ERROR_INVALID_EVENT_TYPE:
		error_text = "JVMDI_ERROR_INVALID_EVENT_TYPE";
		break;
	    case JVMDI_ERROR_ILLEGAL_ARGUMENT:
		error_text = "JVMDI_ERROR_ILLEGAL_ARGUMENT";
		break;
	    case JVMDI_ERROR_OUT_OF_MEMORY:
		error_text = "JVMDI_ERROR_OUT_OF_MEMORY";
		break;
	    case JVMDI_ERROR_ACCESS_DENIED:
		error_text = "JVMDI_ERROR_ACCESS_DENIED";
		break;
	    case JVMDI_ERROR_VM_DEAD:
		error_text = "JVMDI_ERROR_VM_DEAD";
		break;
	    case JVMDI_ERROR_INTERNAL:
		error_text = "JVMDI_ERROR_INTERNAL";
		break;
	    case JVMDI_ERROR_UNATTACHED_THREAD:
		error_text = "JVMDI_ERROR_UNATTACHED_THREAD";
		break;
	}
	if (error_text == NULL) {
		EPRINT("%s: JVMDI error code %d", message, (int)err);
	} else {
		EPRINT("%s: %s", message, error_text);
	}
}
